#include <stdio.h>
#include <setjmp.h>
#include <iocslib.h>
#include <math.h>
#include <time.h>
#include "complex.h"

#define USAGE "\
}fuW`\n\
gp@: mandel [reMin imMax scLen [scSize [mxCnt]]]\n\
  Q̏lɂ reMin=ŏ, imMax=ő, scLen=ӂ̒\n\
  scSize=ʃTCY(0c256~256hbg, 1c512~512hbg)[0]\n\
  mxCnt=񐔐(1`65535)[256]\n\
"

/* ʃTCỸftHg */
#define SC_SIZE 0

/* vZ͈͂̃ftHg */
#define RE_MIN (-2.0)
#define IM_MAX (2.0)
#define SC_LEN (4.0)

/* ő僋[v񐔂̃ftHg */
#define MX_CNT 256

/* L[`FbN */
#define keysns() \
({ \
  int _k_ = 0; \
  while (B_KEYSNS()) _k_ = B_KEYINP() & 0xff ? : _k_; \
  _k_; \
})

double reMin = RE_MIN;  /* ŏ */
double imMax= IM_MAX;  /* ő */
double scLen = SC_LEN;  /* ӂ̒ */
int scSize = SC_SIZE;  /* ʃTCY(0c256~256hbg, 1c512~512hbg) */
int mxCnt = MX_CNT;  /* 񐔐(1`65535) */

unsigned short *paTable;  /* pbge[u */

void make_palet_table(void);  /* pbge[u */
void init_screen(void);  /* ʂ̏ */
void tini_screen(void);  /* ʂ̌n */

/* lcŃ}fuW̑Q̔񐔂Ԃ */
int iteration(complex c, int limit_cnt)
{
  complex z;
  int cnt;

  if (setjmp(cjmpenv)) {
    return limit_cnt;  /* vZłȂ */
  }
  cnt = limit_cnt;
  z = c;
  while (cnt > 0 && cabs2(z) <= 4.0) {
    /* }fuW̑Q z=z^2+c */
    z = cadd(cpow2(z), c);
    cnt--;
  }
  return limit_cnt - cnt;
}

/* `惋[`̖{ */
void draw_body()
{
  unsigned short *a;
  complex c;
  double step;
  unsigned short scCnt;
  unsigned short reCnt;
  unsigned short imCnt;
  complex c0;

  scCnt = (scSize ? 512 : 256);
  step = scLen / (double)scCnt;

  /* VRAM̏݃AhX */
  a = (unsigned short *)0xc00000;

  c0 = tocomplex(reMin, imMax);

  /* ̃[v */
  for (imCnt = 0; imCnt < scCnt; imCnt++) {
    {
      unsigned short *b;
      b = a;
      /* ꂩ`悷郉X^߂̓_` */
      for (reCnt = 0; reCnt < 512; reCnt += 8) {
	*b = 0xffff;
	b += 8;
      }
    }

    c = c0;

    /* 𑜓xɉĎ̃[vŜ𕪂 */
    if (scSize == 0) {
      /* 256~256hbg */

      /* ̃[v */
      for (reCnt = 0; reCnt < scCnt; reCnt++) {
	unsigned short col;

	/* Q̔񐔂𐔂ăpbge[uQƂ */
	col = paTable[iteration(c, mxCnt)];

	/* 𑜓xɉ傫̓_VRAMɏ */
	*a++ = col;
	*a++ = col;
	a[512-2] = col;
	a[512-1] = col;

	/* ɐi */
	Re(c) += step;
      }
    } else {
      /* 512~512hbg */

      /* ̃[v */
      for (reCnt = 0; reCnt < scCnt; reCnt++) {
	/* Q̔񐔂𐔂ăpbge[uQƂ */
	/* 𑜓xɉ傫̓_VRAMɏ */
	*a++ = paTable[iteration(c, mxCnt)];

	/* ɐi */
	Re(c) += step;
      }
    }

    /* 𑜓xɉVRAM̏݃AhX␳ */
    if (scSize == 0) {
      a += 512;
    }

    /* ɐi */
    Im(c0) -= step;

    /* L[ꂽ璆~ */
    if (keysns()) {
      break;
    }
  }
}

void main(int argc, char *argv[])
{
  clock_t tm0, tm1;

  /* ʂ̏ */
  init_screen();

  /* R}hC̃p[^擾 */
  switch (argc) {
  case 6:
    sscanf(argv[5], "%d", &mxCnt);
  case 5:
    sscanf(argv[4], "%d", &scSize);
  case 4:
    sscanf(argv[3], "%lf", &scLen);
    sscanf(argv[2], "%lf", &imMax);
    sscanf(argv[1], "%lf", &reMin);
  case 1:
    break;
  default:
    printf(USAGE);
    return;
  }

  /* pbge[u */
  make_palet_table();

  /* X[p[oCU[hֈڍs */
  B_SUPER(0);

  /* vJn */
  {
    clock_t t = clock();
    while ((tm0 = clock()) == t);
  }

  /* `惋[`̖{ */
  draw_body();

  /* vI */
  tm1 = clock();

  /* ʂ̌n */
  tini_screen();

  /* vԂ\ */
  printf("vԂ %.8g błD\n", ((double)(tm1 - tm0)) / CLK_TCK);
}
